<?php
/**
 * Stripe API Constants *(for site owners)*.
 *
 * Copyright: © 2009-2011
 * {@link http://websharks-inc.com/ WebSharks, Inc.}
 * (coded in the USA)
 *
 * This WordPress plugin (s2Member Pro) is comprised of two parts:
 *
 * o (1) Its PHP code is licensed under the GPL license, as is WordPress.
 *   You should have received a copy of the GNU General Public License,
 *   along with this software. In the main directory, see: /licensing/
 *   If not, see: {@link http://www.gnu.org/licenses/}.
 *
 * o (2) All other parts of (s2Member Pro); including, but not limited to:
 *   the CSS code, some JavaScript code, images, and design;
 *   are licensed according to the license purchased.
 *   See: {@link http://s2member.com/prices/}
 *
 * Unless you have our prior written consent, you must NOT directly or indirectly license,
 * sub-license, sell, resell, or provide for free; part (2) of the s2Member Pro Add-on;
 * or make an offer to do any of these things. All of these things are strictly
 * prohibited with part (2) of the s2Member Pro Add-on.
 *
 * Your purchase of s2Member Pro includes free lifetime upgrades via s2Member.com
 * (i.e., new features, bug fixes, updates, improvements); along with full access
 * to our video tutorial library: {@link http://s2member.com/videos/}
 *
 * @package s2Member\API_Constants
 * @since 140617
 */
if(!defined('WPINC')) // MUST have WordPress.
	exit('Do not access this file directly.');

if(!class_exists('c_ws_plugin__s2member_pro_stripe_constants'))
{
	/**
	 * Stripe API Constants *(for site owners)*.
	 *
	 * @package s2Member\API_Constants
	 * @since 140617
	 */
	class c_ws_plugin__s2member_pro_stripe_constants
	{
		/**
		 * Stripe API Constants *(for site owners)*.
		 *
		 * @package s2Member\API_Constants
		 * @since 140617
		 *
		 * @attaches-to ``add_filter('ws_plugin__s2member_during_constants_c');``
		 *
		 * @param array $c Checksum array should be passed through by the Filter.
		 * @param array $vars Array of defined variables, passed through by the Filter.
		 *
		 * @return array Checksum array with new indexes for Constant values.
		 */
		public static function stripe_constants($c, $vars)
		{
			/**
			 * Flag indicating the Stripe Gateway is active.
			 *
			 * @package s2Member\API_Constants
			 * @since 140617
			 *
			 * @var bool
			 */
			if(!defined('S2MEMBER_PRO_STRIPE_GATEWAY'))
				define('S2MEMBER_PRO_STRIPE_GATEWAY', ($c[] = TRUE));

			return $c; // Return $c calculation values.
		}
	}
}